#! /usr/bin/env ruby
require "numru/gphys"
include NumRu

################
$nx=16
$ny=17
$ndays=168
#################

def read_datas(filename, na_obj)
 lines = File.open(filename, "r").readlines
 for nday in 0..$ndays-1  
  target_lineNo = nday * ($nx + 1)  + 1
  #p "read data: #{nday}"
    for m in 0..$nx-1
	line = lines[target_lineNo+m]
	dat1 = line.split(" ")
	data_n1 = NArray.to_na(dat1)
        n=0
	data_n1.each{ |val|
		na_obj[m, n, nday] = val.to_f
		n=n+1
	}
    end
    #p na_obj[true, true,nday]
  end
end

x_a=VArray.new(NArray.sfloat($nx).indgen, 
            {"long_name"=>"grid index for x direction", "unit"=>"non"}, "i")
x = Axis.new.set_pos(x_a)

y_a=VArray.new(NArray.sfloat($ny).indgen, 
            {"long_name"=>"grid index for y direction", "unit"=>"non"}, "j")
y = Axis.new.set_pos(y_a)

t_a=VArray.new(NArray.sfloat($ndays).indgen, 
            {"long_name"=>"days", "unit"=>"days"}, "days")
t = Axis.new.set_pos(t_a)

na_temper=NArray.sfloat($nx, $ny, $ndays)
read_datas("temperature.dat", na_temper)
data_T2=VArray.new(na_temper, 
    {"long_name"=>"temperature at level2", "unit"=>"K"}, "T2")

na_sf4=NArray.sfloat($nx, $ny, $ndays)
read_datas("sf4.dat", na_sf4)
data_sf4 = VArray.new(na_sf4, 
    {"long_name"=>"stream function at level4", "unit"=>"m^2/s"}, "sf4")

na_omega2=NArray.sfloat($nx, $ny, $ndays)
read_datas("Vp.dat", na_omega2)
data_omega2 = VArray.new(na_omega2, 
    {"long_name"=>"vertical velocity(dp/dt) at level2", "unit"=>"Pa/s"}, "omega2")


grid_xyt = Grid.new(x,y,t)

ncfile = NetCDF.create("sf4_T2.nc")
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_xyt, data_T2))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_xyt, data_sf4))
GPhys::NetCDF_IO.write(ncfile, GPhys.new(grid_xyt, data_omega2))
ncfile.close

