#! /usr/bin/env ruby
require "numru/ggraph"
include NumRu

phys_name=ARGV.shift

gphys = 0.0
expr_u2 = 0.0
target_days=132

if(phys_name != "u2") then
    gphys = GPhys::IO.open('zonal_mean.nc', phys_name)
else
    gphys_u1 = GPhys::IO.open('zonal_mean.nc', 'u1')
    gphys_u3 = GPhys::IO.open('zonal_mean.nc', 'u3')

    expr1_u2 = (gphys_u1.val + gphys_u3.val)/2.0
    data_u2 = VArray.new(expr1_u2, 
         {"long_name"=>"zonal velocity level 2", "unit"=>"m/s"}, "u2")
    gphys = GPhys.new(gphys_u1.grid_copy, data_u2)
end

gphys_p = GPhys::IO.open('phillips_zonal_mean.nc', phys_name)


mj = DCL.udpget('indxmj')
mn = DCL.udpget('indxmn')

#DCL::gropn(4)
DCL::swpset('ldump', true)
DCL::gropn(4)
DCL::sgpset('lcntl', false)
DCL.sgpset('lfprop', true)
DCL::uzfact(0.9)

g_max= gphys.val[true, target_days].max(0)
g_min= gphys.val[true, target_days].min(0)
gp_max= gphys_p.val[true, 0].max(0)
gp_min= gphys_p.val[true, 0].min(0)
p g_max
max=0.0
min=0.0
if g_max < gp_max then 
   max = gp_max
else
   max = g_max
end

if g_min < gp_min then 
   min = g_min
else
   min = gp_min
end

GGraph.line(gphys_p.cut(true, target_days), true, 'max'=>max*1.05, 'min'=>min*1.05, 'index'=>2,  'type'=>2)
GGraph.line(gphys.cut(true, target_days), false,  'index'=>2, 'type'=>1)
DCL::grcls
