#! /usr/bin/env ruby
require "numru/ggraph"
include NumRu

gphys_V1 = GPhys::IO.open('zonal_mean.nc', 'V1')

start_days=130

levels1 = NArray.sfloat(21).indgen!*0.2
levels1[] = levels1[] -2.0
levels = NArray.sfloat(30).indgen!* 0.1
levels[] = levels[] -1.8
mj = DCL.udpget('indxmj')
mn = DCL.udpget('indxmn')

#DCL::gropn(4)
DCL::swpset('ldump', true)
DCL::gropn(4)
DCL::sgpset('lcntl', false)
DCL.sgpset('lfprop', true)
DCL::uzfact(0.9)

p gphys_V1.val[true, 129..164]
p levels1

GGraph.set_fig('viewport'=>[0.05,0.86, 0.25,0.75])
GGraph.tone(gphys_V1.cut(0..15, 128..160), true, 'levels'=>levels, 'exchange'=>true)
#GGraph.contour(gphys_u4.cut(true, 129..164), false, 'levels'=>levels1, 
#   'index'=> mn, 'exchange'=>true)
GGraph.contour(gphys_V1.cut(0..15,128..160), false, 
   'levels'=>levels1, 'index'=>[mj], 'line_type'=>[1], 'label'=>true, 'exchange'=>true)
GGraph.color_bar
DCL::grcls
