#! /usr/bin/env ruby
require "numru/ggraph"
include NumRu

gphys_omega2 = GPhys::IO.open('sf4_T2.nc', 'omega2')
gphys_sf4 = GPhys::IO.open('sf4_T2.nc', 'sf4')
period = 163#gphys_omega2.axis('days').length

s_days=130
cntr_num = (gphys_omega2.val[true, true, s_days..163].max-gphys_omega2.val[true, true, s_days..163].min)/1.26e-01
p cntr_num
levels1 = 1.26e-01 * NArray.float(cntr_num.to_i+1).indgen!
levels1[] = levels1[] + gphys_omega2.val[true, true, s_days..161].min

cntr_num2 = (gphys_sf4.val.max-gphys_sf4.val.min)/6.4e06
levels2 = 6.4e06 * (NArray.float(cntr_num2.to_i+1).indgen!)
levels2[] = levels2[] + gphys_sf4.val.min

mj = DCL.udpget('indxmj')
mn = DCL.udpget('indxmn')

#DCL::gropn(1)
DCL::swpset('ldump', true)
DCL::gropn(4)
DCL::sgpset('lcntl', false)
DCL.sgpset('lfprop', true)
DCL::uzfact(0.9)

for i in s_days..period-1
 GGraph.tone(gphys_omega2.cut(true, true, i), true, 'levels'=>levels1)
 GGraph.contour(gphys_omega2.cut(true, true, i), false, 'levels'=>levels1, 
   'index'=> mn)
 GGraph.contour(gphys_sf4.cut(true, true, i), false, 
   'levels'=>levels2, 'index'=>[mn, mj], 'line_type'=>[2])
 GGraph.color_bar
 #DCL::grcls
end
