#! /usr/bin/env ruby

require "numru/gphys"
require "numru/ggraph"
include NumRu

load "param_setup.rb"

start_days = 141
av_days = 11
r_i = 1..15
r_iup = r_i.first+1..r_i.last+1
r_idwn = r_i.first-1..r_i.last-1

period=start_days..start_days+(av_days-1)
gphys_u1 = GPhys::IO.open('zonal_mean.nc', 'u1')
gphys_u3 = GPhys::IO.open('zonal_mean.nc', 'u3')
gphys_V1 = GPhys::IO.open('zonal_mean.nc', 'V1')

na_Du1Dt = NArray.float(14)
na_Du3Dt = NArray.float(14)
na_VrDif1 = NArray.float(14)
na_VrDif3 = NArray.float(14)
na_HtFlx1 = NArray.float(14)
na_HtFlx3 = NArray.float(14)
na_Col1 = NArray.float(14)
na_SurfF = NArray.float(14)

na_V1 = NArray.float(14)
na_u1 = NArray.float(14+2)
na_u3 = NArray.float(14+2)

r_i0=0..15
r_i0up=r_i0.first+1..r_i0.last+1
na_V1 = gphys_V1.val[r_i0, period].mean(1)
na_u1 = (gphys_u1.val[r_i0, period].mean(1) + gphys_u1.val[r_i0up, period].mean(1))/2.0
na_u3 = (gphys_u3.val[r_i0, period].mean(1) + gphys_u3.val[r_i0up, period].mean(1))/2.0

r_i=1..14
r_iup=r_i.first+1..r_i.last+1
r_idwn=r_i.first-1..r_i.last-1
na_Du1Dt[] = ((gphys_u1.val[r_i, period.last] + gphys_u1.val[r_iup, period.last]) - (gphys_u1.val[r_i, period.first] + gphys_u1.val[r_iup, period.first])) / av_days.to_f / 2.0
na_Du3Dt[] = ((gphys_u3.val[r_i, period.last] + gphys_u3.val[r_iup, period.last]) - (gphys_u3.val[r_i, period.first] + gphys_u3.val[r_iup, period.first])) / av_days.to_f / 2.0

na_Col1[] = F0 * na_V1[r_i] * One_day

na_VrDif1[] = A * ( na_u1[r_iup] + na_u1[r_idwn] - 2.0*na_u1[r_i] ) / Dy**2 * One_day
na_VrDif3[] = A * ( na_u3[r_iup] + na_u3[r_idwn] - 2.0*na_u3[r_i] ) / Dy**2 * One_day

na_SurfF[] = - K * ( 1.5 * na_u3[r_i] - 0.5*na_u1[r_i] ) * One_day

na_HtFlx1 = na_Du1Dt - na_Col1 - na_VrDif1 
na_HtFlx3 = na_Du3Dt + na_Col1 - na_VrDif3 - na_SurfF
 
puts "layer1"
for i in 0..na_Du1Dt.total-1
  puts "#{na_Du1Dt[i]} #{na_Col1[i]} #{na_VrDif1[i]} #{na_HtFlx1[i]}"
end

puts "layer3"
for i in 0..na_Du1Dt.total-1
  puts "#{na_Du3Dt[i]} #{-na_Col1[i]} #{na_VrDif3[i]} #{na_HtFlx3[i]} #{na_SurfF[i]}"
end

