#ifndef FORECAST_H
#define FORECAST_H

#include "Param_List.h"
#include "Field_Data_Manager.h"

// GMathLib 𗘗p邽߂̃wb_[t@C̃CN[h
#include <gmathcore/GMatrix.h>
#include <gmathcore/GVector.h>

using namespace GMathLib;

/**
 * \NX
 */
class Forecast{

public:

    /**
     * RXgN^
     */
    Forecast(const Param_List& pm_list);

    /**
     * fXgN^
     */
    ~Forecast();

    /**
     * vZ[vɓOɕKxĂяo.
     */
    double Prepair(Param_List& pm, Field_Data_Manager& data_manager);

    /**
     * Forecast NXJE^i߂.
     */
    void Increment_TimeStep(){
	time_step++;
    }

    /**
     * ̌̕vZL͖.
     */
    void Enable_Disturb_Eq(bool flag){
         distb_cal_flag = flag;
    }

    /**
     * First run tO𗧂Ă. 
     * tO𗧂ĂĂ, ڂ̎ԐϕOiIC[@ōs. 
     */
     void Set_First_Run(){
      first_run_flag = true;
     }

    /**
     * |eVQx, |eVQx̎ԔWvZ.
     */
    void Calc_PV_Time_Evol(Param_List& pm, Field_Data_Manager& data_manager);

    /**
     * ߂|eVQxꂩ痬֐ff֐.
     */
    void Diagnose_Stream_Function(Param_List& pm, Field_Data_Manager& data_manager);

    /**
     *  p xff֐.
     */
    void Diagnose_v_p_Velocity(Param_List& pm, Field_Data_Manager& data_manager);
    
    /**
     * Qxff֐.
     */
    void Diagnose_Vorcity(Param_List& pm, Field_Data_Manager& data_manager);

    /**
     * gď쐬, Ϗɉ֐. 
     */
    void Create_Disturb_Field(Param_List& pm, Field_Data_Manager& dm);
    
    /**
     * OŕύXp[^, ̃NX̃p[^ɔf֐.
     */
    void Configure_Parameter(const Param_List& pm);

private:
    /**
     *  1 XebvڂɕKvȃp[^̐ݒs֐.
     */
    void Configure_First_Run_Param(Param_List& pm);


private:
    /**
     * |eVQx̏̎ԔWvZ֐.
     */
    void calc_PV_Disturb_Time_Evol(Param_List& pm, Field_Data_Manager& data_manager);
    
    /**
     * |eVQx̓Ϗ̎ԔWvZ֐.
     */
    void calc_PV_Mean_Time_Evol(Param_List& pm, Field_Data_Manager& data_manager);

   
    /**
     * |eVQx̓ϏƏ̎ԔWvZO, 炩ߌĂяoȂ
     * ȂȂ֐.
     */
    void calc_PV_Time_Evol_Prepair(Param_List& pm, Field_Data_Manager& data_manager);

    /**
     * ֐̓Ϗff֐.
     */
    void diagnose_SF_Mean(Param_List& pm, Field_Data_Manager& data_manager);

    /**
     * ֐̏ff֐.
     */
    void diagnose_SF_Disturb(Param_List& pm, Field_Data_Manager& data_manager);
    
    double alpha;
    double b;
    double c;
    double h;
    double epsilon;
    double mu1;
    double mu3;

    int time_step;

    GMatrix *p_chi1;
    GVector *p_chi1_mean;
    GMatrix *p_chi1_distb;
    
    GMatrix *p_chi3;
    GVector *p_chi3_mean;
    GMatrix *p_chi3_distb;

    GMatrix *p_adv_mx1;
    GMatrix *p_adv_mx3;

    // ϗʂ̏ۂɎgsIuWFNg
    GMatrix *p_A;
    GVector *p_pv_mean13;
    
    // ̏ɘa@ŉۂɎgsIuWFNg
    GMatrix *p_pv_distb13;

    bool distb_cal_flag;

    bool first_run_flag;
};

#endif
