#ifndef OUTPUT_DATA_H
#define OUTPUT_DATA_H

#include "Field_Data_Manager.h"
#include "Data_Analysis.h"

// C++ WNXCup̂ɕKvȃwb_[t@C
// ̃CN[h
#include <string>
#include <iostream>
#include <fstream>

//GMathLib 𗘗p̂ɕKvȃwb_[CN[h
#include <gmathcore/GMatrix.h>
#include <gmathcore/GVector.h>
#include <gfd/GConstants.h>

using namespace GMathLib;
using namespace GMathLib::GFD::GConstants;

/**
 * f[^o͂ǗNX
 */
class Output_Data
{
public:
    
    /**
     * RXgN^
     */
    Output_Data()
    {
        time = 0;

        // AEgvbgt@C̏񏑂݃tO,
	// Ă.
        for(int i=0; i < FILE_NUM; i++){
	    first_openflag[i] = true;
	}
    }

    /**
     * 250 hPa ̃|eVQx̓Ϗt@Cɏo͂֐.
     */
    void Output_Mean_PV1_Data(Param_List& pm, Field_Data_Manager& dm){
       GVector* p_pv1_mean = dm.Get_PV_Mean(Field_Data_Manager::PV_MEAN_LAYER1);
       double delx2 = pm.del_x * pm.del_x;

       file_open("pv1_mean.dat", first_openflag[PV1_M]);
       
       ofs << time << " ";

       for(int j=0; j < p_pv1_mean->Size(); j++){
           ofs <<  p_pv1_mean->Get(j)  / delx2  << " "; 
        }

	ofs << std::endl;
	ofs.close();
    }

    /**
     * 750 hPa ̃|eVQx̓Ϗt@Cɏo͂֐.
     */
    void Output_Mean_PV3_Data(Param_List& pm, Field_Data_Manager& dm){
       GVector* p_pv3_mean = dm.Get_PV_Mean(Field_Data_Manager::PV_MEAN_LAYER3);
       double delx2 = pm.del_x * pm.del_x;

       file_open("pv3_mean.dat", first_openflag[PV3_M]);
       
       ofs << time << " ";

       for(int j=0; j < p_pv3_mean->Size(); j++){
           ofs <<  p_pv3_mean->Get(j)  / delx2  << " "; 
        }

	ofs << std::endl;
	ofs.close();
    }

    /**
     * 1000 hPa ̗֐̏t@Cɏo͂֐
     */
    void Output_Disturb_SF4_Data(Param_List& pm, Field_Data_Manager& dm){
       GMatrix* p_sf1_d = dm.Get_Stream_Func_Disturb(Field_Data_Manager::SF_DISTB_LAYER1_BEFORE);
       GMatrix* p_sf3_d = dm.Get_Stream_Func_Disturb(Field_Data_Manager::SF_DISTB_LAYER3_BEFORE);
       int jmax = p_sf1_d->Column();
       int imax = p_sf1_d->Row();

       file_open("sf4_d.dat", first_openflag[SF4_D]);

       ofs << time  << std::endl;

       for(int i=0; i < imax; i++){
           for(int j=0; j < jmax; j++){
               ofs <<  ( 3.0 * p_sf3_d->Get(i, j) - p_sf1_d->Get(i, j) ) / 2.0  << " "; 
           }
	   ofs << std::endl;
        }

	ofs.close();
    }

    /**
     * 1000 hPa ̗֐t@Cɏo͂֐
     */
    void Output_SF4_Data(Param_List& pm, Field_Data_Manager& dm){
       GMatrix* p_sf1 = dm.Get_Stream_Func(Field_Data_Manager::SF_LAYER1_BEFORE);
       GMatrix* p_sf3 = dm.Get_Stream_Func(Field_Data_Manager::SF_LAYER3_BEFORE);
       int jmax = p_sf1->Column();
       int imax = p_sf1->Row();

       file_open("sf4.dat", first_openflag[SF4]);

       ofs << time  << std::endl;

       for(int i=0; i < imax; i++){
           for(int j=0; j < jmax; j++){
               ofs <<  ( 3.0 * p_sf3->Get(i, j) - p_sf1->Get(i, j) ) / 2.0  << " "; 
           }
	   ofs << std::endl;
        }

	ofs.close();
    }

    /**
     * 500 hPa ̉xt@Cɏo͂֐
     */
    void Output_Temperature_Data(Param_List& pm, Field_Data_Manager& dm){
       int imax = pm.num_x;
       int jmax = pm.num_y;

       file_open("temperature.dat", first_openflag[TEMPARATURE]);

       ofs << time  << std::endl;

       for(int i=0; i < imax; i++){
           for(int j=0; j < jmax; j++){
               ofs <<  analysis.Temparature(pm, dm, i, j) << " "; 
           }
	   ofs << std::endl;
        }

	ofs.close();
    }

    /**
     * 250 hPa ̗֐̓Ϗt@Cɏo͂֐
     */
    void Output_Mean_SF1_Data(Param_List& pm, Field_Data_Manager& dm){
       GVector* p_sf1_mean = dm.Get_Stream_Func_Mean(Field_Data_Manager::SF_LAYER1_BEFORE);
       int jmax = p_sf1_mean->Size();

       file_open("sf1_mean.dat", first_openflag[SF1_M]);

       ofs << time << " ";
       for(int j=0; j < jmax; j++){
           ofs <<  p_sf1_mean->Get(j)  << " "; 
        }

	ofs << std::endl;
	ofs.close();
    }

    /**
     * 750 hPa ̗֐̓Ϗt@Cɏo͂֐
     */
    void Output_Mean_SF3_Data(Param_List& pm, Field_Data_Manager& dm){
       GVector* p_sf3_mean = dm.Get_Stream_Func_Mean(Field_Data_Manager::SF_LAYER3_BEFORE);
       int jmax = p_sf3_mean->Size();

       file_open("sf3_mean.dat", first_openflag[SF3_M]);

       ofs << time << " ";
       for(int j=0; j < jmax; j++){
           ofs <<  p_sf3_mean->Get(j)  << " "; 
        }

	ofs << std::endl;
	ofs.close();
    }

    /**
     * 500 hPa ̉x̓Ϗt@Cɏo͂֐
     */
    void Output_Mean_Temparature_Data(Param_List& pm, Field_Data_Manager& dm){
       int jmax = dm.Get_Stream_Func_Mean(Field_Data_Manager::SF_LAYER1_BEFORE)->Size();
       
       file_open("T_mean.dat", first_openflag[T_M]);

       ofs << time << " ";
       for(int j=0; j < jmax; j++){
           ofs <<  analysis.Zonal_Mean_Temparature(pm, dm, j)  << " "; 
        }
	
	ofs << std::endl;
	ofs.close();
    }

    /**
     * 250 hPa ̓x̑я󕽋ς̃f[^t@Cɏo֐.
     */
    void Output_Mean_u1(Param_List& pm, Field_Data_Manager& dm){
       int jmax = dm.Get_Stream_Func_Mean(Field_Data_Manager::SF_LAYER1_BEFORE)->Size();
       
       file_open("u1_mean.dat", first_openflag[U1_M]);
  
       ofs << time << " ";
       for(int j=1; j < jmax-1; j++){
           ofs <<  analysis.Zonal_Mean_u1(pm, dm, j)  << " "; 
        }

	ofs << std::endl;
	ofs.close();
    }

    /**
     * 750 hPa ̓x̑я󕽋ς̃f[^t@Cɏo֐.
     */
    void Output_Mean_u3(Param_List& pm, Field_Data_Manager& dm){
       int jmax = dm.Get_Stream_Func_Mean(Field_Data_Manager::SF_LAYER3_BEFORE)->Size();
       
       file_open("u3_mean.dat", first_openflag[U3_M]);
  
       ofs << time << " ";
       for(int j=1; j < jmax-1; j++){
           ofs <<  analysis.Zonal_Mean_u3(pm, dm, j)  << " "; 
        }

	ofs << std::endl;
	ofs.close();
    }

    /**
     * 1000 hPa ̓x̑я󕽋ς̃f[^t@Cɏo֐.
     */
    void Output_Mean_u4(Param_List& pm, Field_Data_Manager& dm){
       int jmax = dm.Get_Stream_Func_Mean(Field_Data_Manager::SF_LAYER1_BEFORE)->Size();
       
       file_open("u4_mean.dat", first_openflag[U4_M]);
  
       ofs << time << " ";
       for(int j=1; j < jmax-1; j++){
           ofs <<  analysis.Zonal_Mean_u4(pm, dm, j)  << " "; 
        }

	ofs << std::endl;
	ofs.close();
    }
 
    /**
     * 250 hPa ̓kx̑я󕽋ς̃f[^t@Cɏo֐.
     */
    void Output_Mean_V1(Param_List& pm, Field_Data_Manager& dm){
       int V1_size = dm.Get_Omega_Mean()->Size() - 1;
       
       file_open("V1_mean.dat", first_openflag[V1_M]);
       ofs << time << " ";
       for(int j=0; j < V1_size; j++){
           ofs << analysis.Zonal_Mean_V1(pm, dm, j) << " ";
       }

       ofs << std::endl;
       ofs.close();
    }

    /**
     * 250 hPa ̉Qx̑я󕽋ς̃f[^t@Cɏo֐.
     */
    void Output_Mean_Vorcity1(Param_List& pm, Field_Data_Manager& dm){
       GVector* p_vr1_m = dm.Get_Vorcity_Mean(Field_Data_Manager::VR_LAYER1);
       int J = dm.Get_Omega_Mean()->Size();

       
       file_open("vorticity_1_mean.dat", first_openflag[VR1_M]);
       ofs << time << " ";
       for(int j=0; j < J; j++){
           ofs << p_vr1_m->Get(j) << " ";
       }

       ofs << std::endl;
       ofs.close();
    }
    
    /**
     * 500 hPa ̉ p x̑я󕽋ς̃f[^t@Cɏo֐.
     */
    void Output_Mean_Vp_Data(Param_List& pm, Field_Data_Manager& dm){
       GVector* p_vp_m = dm.Get_Omega_Mean();
       int J = dm.Get_Omega_Mean()->Size();

       
       file_open("Vp_mean.dat", first_openflag[Vp_M]);
       ofs << time << " ";
       for(int j=0; j < J; j++){
           ofs << p_vp_m->Get(j) << " ";
       }

       ofs << std::endl;
       ofs.close();
    }
    
    /**
     * 500 hPa ̉ p x̃f[^t@Cɏo͂֐
     */
    void Output_Vp_Data(Param_List& pm, Field_Data_Manager& dm){
       int imax = pm.num_x;
       int jmax = pm.num_y;
       GMatrix* p_vp = dm.Get_Omega();

       file_open("Vp.dat", first_openflag[Vp]);

       ofs << time  << std::endl;

       for(int i=0; i < imax; i++){
           for(int j=0; j < jmax; j++){
               ofs <<  p_vp->Get(i, j) << " "; 
           }
	   ofs << std::endl;
        }

	ofs.close();
    }

    /**
     * GlM[EGlM[ϊɂĂ̏t@Co֐.
     */
    void Output_Energy_Energy_Transform(Param_List& pm, Field_Data_Manager& dm)
    {
       file_open("energy_cycle.dat", first_openflag[ENERGY_CYCLE]);
       
       ofs << time << " ";
       ofs << analysis.K_Disturb(pm, dm) << " ";
       ofs << analysis.K_Mean(pm, dm) << " ";
       ofs << analysis.P_Disturb(pm, dm) << " ";
       ofs << analysis.P_Mean(pm, dm) << " ";
       
       ofs << analysis.Mean_Q_To_Mean_P(pm, dm) << " ";
       ofs << analysis.Mean_P_To_Disturb_P(pm, dm) << " ";
       ofs << analysis.Disturb_P_To_Disturb_K(pm, dm) << " ";
       ofs << analysis.Disturb_K_To_Mean_K(pm, dm) << " ";
       ofs << analysis.Mean_P_To_Mean_K(pm, dm) << " ";
       ofs << analysis.Mean_K_To_k(pm, dm) << " ";
       ofs << analysis.Disturb_K_To_k(pm, dm) << " ";
       ofs << analysis.Mean_K_To_A(pm, dm) << " ";
       ofs << analysis.Disturb_K_To_A(pm, dm) << " ";
       ofs << analysis.Mean_P_To_A(pm, dm) << " ";
       ofs << analysis.Disturb_P_To_A(pm, dm) << std::endl;

       ofs.close();
    }
    

    /**
     * f[^o̓NXێ鎞ϐXV֐.
     */
    void Update_Time(double t){
        time = t;    
    }


private:
    
    void file_open(std::string file_name, bool& fs_openflag){
       std::string file_path = "./data/" + file_name;

       if(fs_openflag){
           ofs.open(file_path.c_str());
           fs_openflag = false;

       }else{
           ofs.open(file_path.c_str(), std::ios::app);
       }
    }
  

    std::ofstream ofs;

    // f[^o̓t@CǗtO̒`
    const static int PV1_M = 0;
    const static int SF1_M = 1;
    const static int T_M = 2;
    const static int U1_M = 3;
    const static int U3_M = 4;
    const static int U4_M = 5;
    const static int SF3_M = 6;
    const static int PV3_M = 7;
    const static int SF4 = 8;
    const static int ENERGY_CYCLE = 9;
    const static int TEMPARATURE = 10;
    const static int SF4_D = 11;
    const static int V1_M = 12;
    const static int VR1_M = 13;
    const static int Vp_M = 14;
    const static int Vp = 15;
    
    // o͂f[^t@C̑
    const static int FILE_NUM = 16;
    
    bool first_openflag[FILE_NUM];

    Data_Analysis analysis;
    double time;
};

#endif
