#ifndef THERMODYN_ENERGY_ANALYSIS_H
#define THERMODYN_ENERGY_ANALYSIS_H

#include "Param_List.h"
#include "Field_Data_Manager.h"
#include "Data_Analysis.h"

// GMathLib を利用するためのヘッダーファイルのインクルード
#include <gmathcore/GMatrix.h>
#include <gmathcore/GVector.h>

#include <iostream>

using namespace GMathLib;


class Thermodyn_Energy_Analysis{
public:
Thermodyn_Energy_Analysis()
: days_count(0)
{
    eq_mx = new GMatrix(17, 5);
}

~Thermodyn_Energy_Analysis(){
    delete eq_mx;
}

void Analysis(Param_List& pm, Field_Data_Manager& dm){
    //GVector* p_T2_mean = dm.Get
    days_count++;
    
    if(days_count == 12)
        return;

    // 左辺第 1 項(time differential of zonal mean T2)    
    if(days_count == 1){
        for(int j=1; j <= 15; j++){
	    eq_mx->Set(j, 0, analysis.Zonal_Mean_Temparature(pm, dm, j));
	}

    }else if(days_count == 11){
        double tmp;

	for(int j=1; j <= 15; j++){
	    tmp = ( analysis.Zonal_Mean_Temparature(pm, dm, j) - eq_mx->Get(j, 0)) / 11;
	    eq_mx->Set(j, 0, tmp);
	}
        
    }
    
    if(days_count == 11){
        eq_mx->Print();
    }
}

private:

Data_Analysis analysis;
int days_count;
GMatrix* eq_mx;

double first_T;

};

#endif
